unit Version;
// Versions-Check (nur Windows)

{$mode objfpc}{$H+}

interface

uses
  SysUtils,
  {$ifdef windows}
  windows,
  {$endif windows}
  Forms;

{$ifdef windows}
function GetVersionInfo : String;
{$endif windows}

implementation
{$ifdef windows}
//http://www.lazarusforum.de/viewtopic.php?t=3893
function GetVersionInfo : String;
var
  sAppName                   : string;
  iAppSize,iLenOfValue       : Dword;
  pcBuf                      : PChar;
  PFinfo                     : PVSFIXEDFILEINFO;
  iMajor, iMinor, iBuild, iRevis : Word;
begin
  iMajor := 0;
  iMinor := 0;
  iBuild := 0;
  iRevis := 0;

  sAppName := Application.ExeName;
  iAppSize:= GetFileVersionInfoSize(PChar(sAppName),iAppSize);
  if iAppSize > 0 then begin
    pcBuf := AllocMem(iAppSize);
    GetFileVersionInfo(PChar(sAppName),0,iAppSize,pcBuf);
    VerQueryValue(pcBuf,'\\',PFInfo,iLenOfValue);
    if iLenOfValue > 0 then begin
       iMajor := HIWord(PFinfo^.dwFileVersionMS);
       iMinor := LOWord(PFinfo^.dwFileVersionMS);
       iBuild := HiWord(PFinfo^.dwFileVersionLS);
       iRevis := LOWord(PFinfo^.dwFileVersionLS);
    end;
    FreeMem(pcBuf,iAppSize);
  end;
  GetVersionInfo := IntToStr(iMajor)+'.'+IntToStr(iMinor)+'.'+
                    IntToStr(iBuild)+'('+IntToStr(iRevis)+')';
end;
{$endif windows}
end.

